/*
 * Copyright (c) 1999, 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef FROMINCHAN_HH
#define FROMINCHAN_HH

#include "element.hh"
#include "string.hh"

extern "C" {
#include <packet.h>
#include <channel.h>
}

class FromInChan : public Element {
public:
	FromInChan();
	~FromInChan();
  
	const char *class_name() const		{ return "FromInChan"; }
	Processing default_processing() const	{ return PUSH; }
  
	FromInChan *clone() const;
	int configure(const String &, ErrorHandler *);
	int initialize(ErrorHandler *);
  
	/* process a packet. return 0 if not wanted after all. */
	int got_packet(packet_t *p);

	/* set the Nodeos InChan pointer. */
	void set_chan(channel_t *chan)		{ _chan = chan; }

private:
	channel_t	*_chan;
};

/*
 * This is the callback for receiving nodeos packets
 */
extern "C" void
click_FromInChan_in(an_packet_t p, void *obj);

#endif /* FROMINCHAN_HH */
